"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LatLngPropType = exports.GeolocHitPropType = exports.BoundingBoxPropType = void 0;
var _propTypes = _interopRequireDefault(require("prop-types"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
var LatLngPropType = _propTypes.default.shape({
  lat: _propTypes.default.number.isRequired,
  lng: _propTypes.default.number.isRequired
});
exports.LatLngPropType = LatLngPropType;
var BoundingBoxPropType = _propTypes.default.shape({
  northEast: LatLngPropType.isRequired,
  southWest: LatLngPropType.isRequired
});
exports.BoundingBoxPropType = BoundingBoxPropType;
var GeolocHitPropType = _propTypes.default.shape({
  _geoloc: LatLngPropType.isRequired
});
exports.GeolocHitPropType = GeolocHitPropType;